
variables:
  DOCKER_PATH_DATA: "/home/gitlab-runner/docker_file/${CI_COMMIT_SHORT_SHA}/"
  DOCKER_VOLUME_NAME: "/home/gitlab-runner/${CI_COMMIT_SHORT_SHA}/" 

.setup_proxy:
  stage: deploy_to_dev
  tags:
    - dev_shell
  script:
    - >
      if docker ps | grep -q nginx-proxy; then echo "nginx-proxy is running"; 
      else echo "nginx-proxy is not running" && 
      docker compose -f ./docker/nginx-proxy/docker-compose.yml up -d ; fi
    - docker ps | grep nginx-proxy
  only:
    - /^feature.*$/
    - develop

 
#Feature
#############################################################
.deploy_feature:
  stage: deploy_to_dev
  tags:
    - dev_shell
  script:
    - mkdir -p $DOCKER_PATH_DATA
    - > 
      sed -e "s/db_\${CI_COMMIT_SHORT_SHA}:/db_${CI_COMMIT_SHORT_SHA}:/g"  
      -e "s/app_\${CI_COMMIT_SHORT_SHA}:/app_${CI_COMMIT_SHORT_SHA}:/g" 
      "./docker/docker-compose.template.yml" > "${DOCKER_PATH_DATA}docker-compose.yml" 
    
    - cat "${DOCKER_PATH_DATA}docker-compose.yml"
    - docker compose -f ${DOCKER_PATH_DATA}docker-compose.yml up -d
    - docker ps --format "table {{.ID}}\t{{.Names}}\t{{.Ports}}"

    - echo "App is deployed at http://${CI_COMMIT_SHORT_SHA}.dev.example.com"
  environment:
    name: feature/$CI_COMMIT_REF_NAME
    url: http://${CI_COMMIT_SHORT_SHA}.dev.example.com:8777
    on_stop: stop_compose_feature # Добавляем скрипт для остановки
  only:
    - /^feature.*$/
  needs:
    - build-docker
    - setup_proxy


stop_compose_feature:
  tags:
    - dev_shell
  stage: deploy_to_dev
  script:
     - docker stop db_mysql_${CI_COMMIT_SHORT_SHA} app_todo_${CI_COMMIT_SHORT_SHA} || true
     - docker rm db_mysql_${CI_COMMIT_SHORT_SHA} app_todo_${CI_COMMIT_SHORT_SHA} || true
     - sudo rm -Rf ${DOCKER_VOLUME_NAME}
     - rm -Rf ${DOCKER_PATH_DATA}
  when: manual
  only:
    - /^feature.*$/
  environment:
    name: feature/$CI_COMMIT_REF_NAME
    action: stop

#Dev
#############################################################

.deploy_develop:
  stage: deploy_to_dev
  tags:
    - dev_shell
  script:
    - docker compose -f ./docker/docker-compose.yml up -d
    - docker ps --format "table {{.ID}}\t{{.Names}}\t{{.Ports}}"
    - echo "App is deployed at http://dev.example.com"
  environment:
    name: $CI_COMMIT_REF_NAME
    url: http://dev.example.com:8777
    on_stop: stop_compose_dev
  needs:
    - build-docker
    - setup_proxy
  only:
    - develop
      
stop_compose_dev:
  tags:
    - dev_shell
  stage: deploy_to_dev
  environment:
    name: $CI_COMMIT_REF_NAME
    action: stop
  script:
    - docker compose -f ./docker/docker-compose.yml down


   
    - echo "delete mysql-data"
  only:
    - develop
  when: manual


#Prod
#############################################################
.release_docker_hub:
  stage: release
  tags:
    - dev_shell
  variables:
    TEST_IMAGE: registry.gitlab.com/lessons_devops/240322/control_ci_cd:main_latest
    RELEASE_IMAGE: ganebaldenis/todo_list_app
  script:
    - docker logout
    - docker pull $TEST_IMAGE
    - export REGISTRY_URL="docker.io"
    - echo $DH_PASS | docker login -u $DH_USERNAME --password-stdin $REGISTRY_URL 
    - docker tag $TEST_IMAGE $RELEASE_IMAGE:$CI_COMMIT_TAG
    - docker tag $TEST_IMAGE $RELEASE_IMAGE:latest
    - docker push $RELEASE_IMAGE:$CI_COMMIT_TAG
    - docker push $RELEASE_IMAGE:latest
  only:
     - tags


.deploy_prod:
  stage: deploy_to_prod
  tags:
    - prod_shell
  script:
    - echo "Setting prod host ansible install - mysql docker runner"
    #- sudo usermod -aG docker gitlab-runner
    #- sudo usermod -aG root gitlab-runner
    - docker stop todo_list_app || true 
    - > 
      docker run -d --rm --name todo_list_app 
      -e MYSQL_HOST=host.docker.internal 
      -e MYSQL_USER=user1 
      -e MYSQL_PASSWORD=password1 
      -e MYSQL_DB=db_todo 
      --add-host host.docker.internal:host-gateway 
      -p 80:3000 
      ganebaldenis/todo_list_app:latest
    
    - docker ps --format "table {{.ID}}\t{{.Names}}\t{{.Ports}}"
    - echo "App is deployed at http://example.com"
  environment:
    name: production
    url: http://example.com
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: manual
    - when: never

#Build-images-app
#############################################################
.build-docker:
  stage: build-images-app
  tags:
    - dev_shell  
  image: docker:stable
  services:
    - docker:dind
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN ${CI_REGISTRY} 
  script:
    - apk update && apk add git
    - git clone https://gitlab.com/lessons_devops/240322/todo-list-app.git ./docker/todo-list-app/    
    - docker build -t "${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME}_latest" ./docker/
    - docker tag "${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME}_latest" "${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME}_${CI_COMMIT_SHORT_SHA}"
    - docker push "${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME}_latest"
    - docker push "${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_NAME}_${CI_COMMIT_SHORT_SHA}"
  only:
    - branches


#Clean
#############################################################
.cleanup_f:
  stage: cleanup
  tags:
    - dev_shell
  script:
     - docker compose -f ${DOCKER_PATH_DATA}docker-compose.yml down || true
     - sudo rm -Rf ${DOCKER_VOLUME_NAME}
     - rm -Rf ${DOCKER_PATH_DATA}
     - docker stop $(docker ps -q) && docker rm $(docker ps -a -q) && docker network prune -f || true
  when: always
  when: manual
  only:
    - /^feature.*$/

.delete_proxy_docker:
  stage: cleanup 
  tags:
    - dev_shell
  script:
     - docker compose -f ./docker/nginx-proxy/docker-compose.yml down || true
  when: manual
  only:
    - /^feature.*$/
    - develop